# solenoidaxeq.sl
# SIMION SL program to set the axial magnetic field (B_x)
# on a finite, thin shell solenoid.
#
# Note: deviations to B off-axis are not included.
# Formula taken from
#   http://www.netdenizen.com/emagnet/solenoids/thinsolenoid.htm
# See also
#   http://www.netdenizen.com/emagnet/index.htm

adjustable mu_0 = 1.26E-6   # permeability constant (H/m)
adjustable i = 1            # wire current (A)
adjustable N = 100          # number of wire turns
adjustable xl = -2          # x position of left end of solenoid (mm)
adjustable xr = 2           # x position of right end of solenoid (mm)
adjustable r  = 1           # radius of solenoid (mm)

sub mfield_adjust
    L = (xr - xl)  # length of solenoid (m)
    x1 = ion_px_mm - xl
    x2 = ion_px_mm - xr

    ion_bfieldx_gu = (mu_0 * i * N) / (2 * L / 1000) *
        (x2 / sqrt(x2*x2 + r*r) - x1 / sqrt(x1*x1 + r*r)) * 10000
    ion_bfieldy_gu = 0
    ion_bfieldz_gu = 0
endsub
